local _,stash = ...
local L = stash.localization
local C = stash.constants
local settings = stash.settings
stash.minimapButton = StashMinimapButton

function stash.minimapButton:Setup()
    self:Update()
    self:RegisterForDrag("LeftButton")
    self:SetFrameLevel(Minimap:GetFrameLevel()+2)
    if settings.ShowMinimapButton then
        self:Show()
    end
end

function stash.minimapButton:Update()
	local angle = settings.MinimapPosition or C.DEFAULT_MINIMAP_POSITION
	self:SetPoint("TOPLEFT",Minimap,"TOPLEFT",52-(80*cos(angle)),(80*sin(angle))-52)
end

function stash.minimapButton:OnEnter()
    stash.tooltips:ShowSimpleTooltip(self,"ANCHOR_LEFT",format(L["%sStash"],C.HEX_WHITE),format(L["Version %s"],GetAddOnMetadata("Stash","Version")))
end

function stash.minimapButton:OnLeave()
    stash.tooltips:HideTooltip()
end

function stash.minimapButton:OnMouseDown()
    self.Icon:SetPoint("CENTER",-1,-2)
    self.Icon:SetVertexColor(0.65,0.65,0.65)
end

function stash.minimapButton:OnMouseUp()
    self.Icon:SetPoint("CENTER")
    self.Icon:SetVertexColor(1,1,1)
end

function stash.minimapButton:OnClick()
    stash.frame:Toggle()
end

function stash.minimapButton:OnDragStart()
    self:SetScript("OnUpdate",self.OnDragUpdate)
end

function stash.minimapButton:OnDragStop()
    self:OnMouseUp()
    self:SetScript("OnUpdate",nil)
end

function stash.minimapButton:OnDragUpdate(elapsed)
	local x,y = GetCursorPosition()
	local minX,minY = Minimap:GetLeft(), Minimap:GetBottom()
	local scale = Minimap:GetEffectiveScale()
    settings.MinimapPosition = math.deg(math.atan2(y/scale-minY-70,minX-x/scale+70))
    self:Update()
end